/*=======================================================================
    p[^t@Cϐǂݍފ֐

    void  parameter_file(argc,argv,filename,keyword,format,p1,p2, ...)

       const int    argc;       R}hC̔z̃TCY
       const char **argv;       R}hC̔zւ̃|C^
       const char *filename;    p[^t@C̖O
       const char *keyword;     p[^Zbg̖O
       const char *format;      tH[}bg 
       const void  *p1,*p2,,,;  p[^ϐւ̃|C^

    <tH[}bg̏>
       "name1 type1 name2 type2 ... "
          name1,name2,,,  t@CŎgĂϐ
          type1,type2,,,  eϐ̓͂̏i%lf, %d Ȃǁj
          I؂蕶ig[Nj #define TOKEN Œ`ꂽ
            ܂܂镶PȏB

    <p[^t@C̏>
        #define COMMENT Œ`ꂽɊ܂܂镶n܂s̓Rg
        #define KEYWORD Œ`ꂽƈvs̓p[^Zbg̋؂

        p[^͂PsɂPŁAOƒlXy[Xŋ؂ĕׂB
          l -       ȂB
          largv[m]  R}hC m ԖڂB
          lkeyboard  L[{[h (  retrun ƑȂBj
          ȊO     ̒lϐɑB
                    ! Al '  ' ň͂܂Ă ' 菜đB
    
    <>  parameter_file(argc,argv,"para","best","a %lf  b %d",&a,&b);
    
          parameter_file(argc,argv,"para","test",
                        "title:%s  a:%lf b:%d",c,&a,&b);
                        
          parameter_file(argc,argv,"para","after",
                        "title:%s a:%lf b:%d",c,&a,&b);
                        
          parameter_file(argc,argv,"para","literal",
                        "title1:%s title2:%s",s1,s2);
          
          ------------------------
          # t@C para ̒g
          /test
          a      10.3
          b      3
          title  wahhaha    !Rڂ͖B

          /best
          title  gahhaha          

          a      10.3
          b      3

          /after
          title  keyboard   L[{[h
          a      argv[1]   R}hCŗ^B
          b      argv[2]   R}hCŗ^B

            /literal
          title1  'keyboard'        s1 ɂ keyboard B
          title2  ''keyboard''   s1 ɂ 'keyboard' B
          
          # Ⴆ΂Ȋ
          -------------------------
========================================================================*/    
#ifndef PARAMETER_FILE_H
#define PARAMETER_FILE_H

#define NUMAX    64       /* p[^̍ő吔                       */
#define TOKEN    " :\n"   /* tH[}bg̃g[N                   */
#define KEYWORD  "/%s"    /* p[^t@Cł̃L[[h̏ */
#define COMMENT  "#!"     /* p[^t@Cł̃Rgs̐擪 */

#include  <stdarg.h>
#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  <ctype.h>

void
parameter_file(int argc,char **argv,
          const char *filename,const char *keyword,const char *args, ...)
{
   char  name[NUMAX][32],type[NUMAX][16];
   void  *pointer[NUMAX];
   int   num,top,last;
   
   char  buffer[1024],word[64],value[64],*s;
   int   n,m,hit,j,k;   
   FILE *file;

   
 /********** ϒ̏ ***********/
   
   /*===== tH[}bgϐ name[] ƌ^ type[]oB=====*/
   strcpy(buffer,args);
   s=strtok(buffer,TOKEN); num=m=0;
   while(s!=NULL){
       if(m==0){
           strcpy(name[num],s); m=1;
       }else{
           if(s[0]!='%'){
               fprintf(stderr,"ERROR in parameter_file(): "
               "%% is missed after '%s' in 3'th arguments.\n",name[num]);
               exit(1);
           }
             strcpy(type[num],s); m=0; num++;
       }
       s=strtok(NULL,TOKEN);
   }
   
   if(m==1){
      fprintf(stderr,"ERROR in parameter_file(): "
      "%% is missed after '%s' in 3'th arguments.\n",name[num]);
      exit(1);
   } 
   
   /*===== p[^ϐւ̃|C^ pointer[] oB======*/
   va_list ap;
   va_start(ap,args);
   for(n=0; n<num; n++) pointer[n]=va_arg(ap,void*);
   va_end(ap);

   
   
 /*********** p[^t@C̓ǂݍ ***********/

   /*===== t@C̃I[v =======*/
   if((file=fopen(filename,"r"))==NULL){
       fprintf(stderr,"ERROR in parameter_file(): "
                      "File %s can't open.\n",filename);
       exit(1);
   }

   /*===== L[[hɑΉp[^Zbg̈ʒuTB=====*/
   top=last=ftell(file);
   if(strcmp(keyword,"")){
      hit=0;
      while(1){
	if(fgets(buffer,sizeof(buffer),file)==NULL || feof(file)) break;
         word[0]='\0';
         sscanf(buffer,KEYWORD,word); if(word[0]=='\0') continue;
         if(!strcmp(word,keyword)){ top =ftell(file); hit++; n=1; }
         else if(n)               { last=ftell(file); n=0; }
      }
      if(last==top) last=ftell(file);            
      if(hit==0 || hit>1){
         fprintf(stderr,"ERROR in parameter_file(): Keyword '%s' ",keyword); 
         if(hit==0) fprintf(stderr,"is not");
         else       fprintf(stderr,"is used %d times",hit);
         fprintf(stderr," in the file '%s'.\n",filename);
         exit(1);
      }
   }

   
   /*===== p[^̑ =====*/
   
   for(n=0; n<num; n++){
      fseek(file,top,0); hit=0;
      
      do{
	if(fgets(buffer,sizeof(buffer),file)==NULL || feof(file)) break;
         word[0]=value[0]='\0';
         sscanf(buffer,"%s %s",word,value);
         if(strchr(COMMENT,word[0]) || value[0]=='\0') continue;
         
         if(!strcmp(word,name[n])){

             if(!strcmp(value,"-")){
                 /*-- ύXȂB---*/
                 
             }else if(!strcmp(value,"keyboard")){ 
                  /*-- W ireturn ݂̂ȂύXȂj---*/
		  while(1){
                    fprintf(stderr,"%s = ",name[n]);
                    if(fgets(buffer,sizeof(buffer),stdin)!=NULL){
			k=strlen(buffer);
			buffer[k-1]='\0';
			/*---- return ݂̂ȂύXȂB------*/
                       if(!strcmp(buffer,"")) break;
			/*---- Ctrl R[hĂ͂ ------*/
			k=strlen(buffer);
			for(j=0;j<k;j++) if(iscntrl(buffer[j])) break; 
		        if(j==k){ sscanf(buffer,type[n],pointer[n]); break; }
		    }
		  }
	      }else if(!strncmp(value,"argv[" ,4) && isdigit(value[5]) && !strcmp(value+6,"]")){
                 /*-- R}hC擾 (ȂG[j--*/
                 value[6]='\0';  m=atoi(value+5);
                 if(m<argc){
                     sscanf(argv[m],type[n],pointer[n]);
                 }else{ 
                    fprintf(stderr,
                        "ERROR in parameter_file(): can't read Parameter '%s' "
                        "for lack of argv[%d].\n",name[n],m);
                    exit(1);
                 }

             }else{
                 /*-- p[^t@C ----*/
                 if(value[0]=='\'' && value[strlen(value)-1]=='\''){
                     /*--- '`' ň͂ł鎞 ' 菜B---*/
                     value[strlen(value)-1]='\0';
                     sscanf(value+1,type[n],pointer[n]);                     
                 }else{
                     sscanf(value,type[n],pointer[n]);
                 }
                 
             }

             hit++;
            }
         
      }while(last!=ftell(file));
      
      if(hit==0 || hit>1){
         fprintf(stderr,"ERROR in parameter_file(): Name '%s' ",name[n]); 
         if(hit==0) fprintf(stderr,"is not");
         else       fprintf(stderr,"is used %d times",hit);
         fprintf(stderr," in the file '%s' for the keyword '%s'.\n"
                       ,filename,keyword);
         exit(1);
      }
      
   }
   
   fclose(file);
}


#undef  NUMAX
#undef  TOKEN
#undef  KEYWORD
#undef  COMMENT

#endif  /* PARAMETER_FILE_H */
