#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#include <algorithm>
#include <functional>
#include <iostream>

#include <boost/random.hpp>
using namespace std;

#include <XRS/Array.h>
using namespace XRS;

int    L;
int    **s;
int    **c;        //饹󥰤Τ
int    *cs,*cn;    //饹, 饹ֹ
int    clusternum; //饹
double p;

void   draw(void);
void   clustering(int);
int    Cluster=1;
void   toggle_view(int){ if(Cluster) Cluster=0; else Cluster=1;}

int main(int argc, char **argv)
{
  int ar=0;
  ar++; if(ar<argc) p=atof(argv[ar]); else p=0.5;
  ar++; if(ar<argc) L=atoi(argv[ar]); else L=400;  
  
  XRS::array(s,L,L);  
  XRS::array(c,L,L);
  
  using namespace boost;
  // 륻̥ĥˡ seed=4259 ǻȤȤ
  // (URL) http://ja.wikipedia.org/wiki/륻̡ĥ
  mt19937            gen(4259);

  //0.01.0μ¿ΰפ
  uniform_real<> dst(0.0,1.0);
  variate_generator<mt19937, uniform_real<> > rand( gen, dst );


  while(1){
  
    // ºݤƻȤ
    for( int i=0; i<L; ++i ) 
       for( int j=0; j<L; ++j) 
          if(rand()<p) s[i][j]=1; else s[i][j]=0;

    if(Cluster) clustering(0);
    draw();
  }
}


#include <XRS/Control.h>
#include <XRS/Graphic.h>
int     w,h;
Graphic_Window W;
Control_Window CW;
//Control_Window PW(W);

void draw(void)
{
  static int Initial=1;
  if(Initial){
    w=h=L;
    CW<<PARAMETER<<"p"<<p;
    W.geometry(w,h,1)<<toggle_view<<"Click for clustering!";
    unsigned long *c=W.color_pixel();
    c[0]=color_pixel((char *)"white");     //XRSǻȤ0ܤο
    c[1]=color_pixel((char *)"limegreen"); //XRSǻȤ1ܤο
    c[2]=color_pixel((char *)"red");       //XRSǻȤ2ܤο
    c[3]=color_pixel((char *)"blue");      //XRSǻȤ3ܤο
    c[4]=color_pixel((char *)"yellow");    //XRSǻȤ4ܤο    
    //PW<<"p"<<p;
    initialize();
    Initial=0;
  }

  checkevent();

  for( int i=0; i<L; ++i )
    for( int j=0; j<L; ++j ){
      if(Cluster){
        if     (c[i][j]==cn[0])  W.point(2,i,j);  
        else if(c[i][j]==cn[1])  W.point(3,i,j);  
        else if(c[i][j]==cn[2])  W.point(4,i,j);
        else                     W.point(s[i][j],i,j);      
      }else{
        W.point(s[i][j],i,j);      
      }
    }

  CW.chev=0; W.chev=0;
  while(!CW.chev && !W.chev) checkevent();
}


class GreaterInt {
public:
    bool operator()(const int& riLeft, const int& riRight) const {
        return cs[riLeft] > cs[riRight]; 
    }
};



void clustering(int)
{
  int N=0;
  for(int i=0; i<L; ++i)
    for(int j=0; j<L; ++j){ if(s[i][j]){ c[i][j]=N; N++; }else{ c[i][j]=L*L;} }

  int changed;
  do{
    changed=0;
    for(int i=0; i<L; ++i)
       for(int j=0; j<L; ++j)
	 if(s[i][j]==1){
	   if(i+1<L  && c[i][j]>c[i+1][j]){ c[i][j]=c[i+1][j]; changed++;}
	   if(i-1>=0 && c[i][j]>c[i-1][j]){ c[i][j]=c[i-1][j]; changed++;}	   
  	   if(j+1<L  && c[i][j]>c[i][j+1]){ c[i][j]=c[i][j+1]; changed++;}
  	   if(j-1>=0 && c[i][j]>c[i][j-1]){ c[i][j]=c[i][j-1]; changed++;}	   
         }
  }while(changed);

  if(cs!=NULL){ delete [] cs;} cs=new int [N]; //饹
  if(cn!=NULL){ delete [] cn;} cn=new int [N]; //饹ֹ
  for(int n=0; n<N; ++n){ cs[n]=0; cn[n]=n;}

  for(int i=0; i<L; ++i)
    for(int j=0; j<L; ++j){ if(s[i][j]){ cs[c[i][j]]++;} }

  sort(cn, cn+N, GreaterInt()); //饹¤ؤ
  for(int n=0; n<N; ++n){ if(cs[cn[n]]==0){ clusternum=n; break;} }
}









